=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Priority: optional
 Maintainer: Hubert Chathi <uhoreg@debian.org>
 Build-Depends:
+ cmake,
  debhelper-compat ( =12),
  doxygen,
  ghostscript,
@@ -17,6 +18,7 @@
 Package: nlohmann-json3-dev
 Section: libdevel
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
 Conflicts:
