## nlohmann-json3 3.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 ## PROJECT
 ## name and version
 ##
-project(nlohmann_json VERSION 3.7.0 LANGUAGES CXX)
+project(nlohmann_json VERSION 3.7.3 LANGUAGES CXX)
 
 ##
 ## INCLUDE
