=== Makefile ===
.PHONY: pretty clean ChangeLog.md release

##########################################################################
# configuration
##########################################################################

# directory to recent compiler binaries
COMPILER_DIR=/Users/niels/Documents/projects/compilers/local/bin

# find GNU sed to use `-i` parameter
SED:=$(shell command -v gsed || which sed)


##########################################################################
# source files
##########################################################################

# the list of sources in the include folder
SRCS=$(shell find include -type f | sort)

# the single header (amalgamated from the source files)
AMALGAMATED_FILE=single_include/nlohmann/json.hpp


##########################################################################
# documentation of the Makefile's targets
##########################################################################

# main target
all:
	@echo "amalgamate - amalgamate file single_include/nlohmann/json.hpp from the include/nlohmann sources"
	@echo "ChangeLog.md - generate ChangeLog file"
	@echo "check - compile and execute test suite"
	@echo "check-amalgamation - check whether sources have been amalgamated"
	@echo "check-fast - compile and execute test suite (skip long-running tests)"
	@echo "clean - remove built files"
	@echo "coverage - create coverage information with lcov"
	@echo "coverage-fast - create coverage information with fastcov"
	@echo "cppcheck - analyze code with cppcheck"
	@echo "cpplint - analyze code with cpplint"
	@echo "clang_tidy - analyze code with Clang-Tidy"
	@echo "clang_analyze - analyze code with Clang-Analyzer"
	@echo "doctest - compile example files and check their output"
	@echo "fuzz_testing - prepare fuzz testing of the JSON parser"
	@echo "fuzz_testing_bson - prepare fuzz testing of the BSON parser"
	@echo "fuzz_testing_cbor - prepare fuzz testing of the CBOR parser"
	@echo "fuzz_testing_msgpack - prepare fuzz testing of the MessagePack parser"
	@echo "fuzz_testing_ubjson - prepare fuzz testing of the UBJSON parser"
	@echo "json_unit - create single-file test executable"
	@echo "pedantic_clang - run Clang with maximal warning flags"
	@echo "pedantic_gcc - run GCC with maximal warning flags"
	@echo "pretty - beautify code with Artistic Style"
	@echo "run_benchmarks - build and run benchmarks"


##########################################################################
# unit tests
##########################################################################

# build unit tests
json_unit:
	@$(MAKE) json_unit -C test

# run unit tests
check:
	$(MAKE) check -C test

# run unit tests and skip expensive tests
check-fast:
	$(MAKE) check -C test TEST_PATTERN=""


##########################################################################
# coverage
##########################################################################

coverage:
	rm -fr build_coverage
	mkdir build_coverage
	cd build_coverage ; CXX=g++-8 cmake .. -GNinja -DJSON_Coverage=ON -DJSON_MultipleHeaders=ON
	cd build_coverage ; ninja
	cd build_coverage ; ctest -E '.*_default' -j10
	cd build_coverage ; ninja lcov_html
	open build_coverage/test/html/index.html

coverage-fast:
	rm -fr build_coverage
	mkdir build_coverage
	cd build_coverage ; CXX=g++-9 cmake .. -GNinja -DJSON_Coverage=ON -DJSON_MultipleHeaders=ON
	cd build_coverage ; ninja
	cd build_coverage ; ctest -E '.*_default' -j10
	cd build_coverage ; ninja fastcov_html
	open build_coverage/test/html/index.html

##########################################################################
# documentation tests
##########################################################################

# compile example files and check output
doctest:
	$(MAKE) check_output -C doc


##########################################################################
# warning detector
##########################################################################

# calling Clang with all warnings, except:
# -Wno-c++2a-compat: u8 literals will behave differently in C++20...
# -Wno-deprecated-declarations: the library deprecated some functions
# -Wno-documentation-unknown-command: code uses user-defined commands like @complexity
# -Wno-exit-time-destructors: warning in json code triggered by NLOHMANN_JSON_SERIALIZE_ENUM
# -Wno-float-equal: not all comparisons in the tests can be replaced by Approx
# -Wno-keyword-macro: unit-tests use "#define private public"
# -Wno-padded: padding is nothing to warn about
# -Wno-range-loop-analysis: items tests "for(const auto i...)"
# -Wno-switch-enum -Wno-covered-switch-default: pedantic/contradicting warnings about switches
# -Wno-weak-vtables: exception class is defined inline, but has virtual method
pedantic_clang:
	$(MAKE) json_unit CXX=c++ CXXFLAGS=" \
		-std=c++11 -Wno-c++98-compat -Wno-c++98-compat-pedantic \
		-Werror \
		-Weverything \
		-Wno-c++2a-compat \
		-Wno-deprecated-declarations \
		-Wno-documentation-unknown-command \
		-Wno-exit-time-destructors \
		-Wno-float-equal \
		-Wno-keyword-macro \
		-Wno-padded \
		-Wno-range-loop-analysis \
		-Wno-switch-enum -Wno-covered-switch-default \
		-Wno-weak-vtables"

# calling GCC with most warnings
pedantic_gcc:
	$(MAKE) json_unit CXX=/usr/local/bin/g++-9 CXXFLAGS=" \
		-std=c++11 \
		-Waddress \
		-Waddress-of-packed-member \
		-Waggressive-loop-optimizations \
		-Waligned-new=all \
		-Wall \
		-Walloc-zero \
		-Walloca \
		-Warray-bounds \
		-Warray-bounds=2 \
		-Wattribute-alias=2 \
		-Wattribute-warning \
		-Wattributes \
		-Wbool-compare \
		-Wbool-operation \
		-Wbuiltin-declaration-mismatch \
		-Wbuiltin-macro-redefined \
		-Wcannot-profile \
		-Wcast-align \
		-Wcast-function-type \
		-Wcast-qual \
		-Wcatch-value=3 \
		-Wchar-subscripts \
		-Wclass-conversion \
		-Wclass-memaccess \
		-Wclobbered \
		-Wcomment \
		-Wcomments \
		-Wconditionally-supported \
		-Wconversion \
		-Wconversion-null \
		-Wcoverage-mismatch \
		-Wcpp \
		-Wctor-dtor-privacy \
		-Wdangling-else \
		-Wdate-time \
		-Wdelete-incomplete \
		-Wdelete-non-virtual-dtor \
		-Wdeprecated \
		-Wdeprecated-copy \
		-Wdeprecated-copy-dtor \
		-Wdeprecated-declarations \
		-Wdisabled-optimization \
		-Wdiv-by-zero \
		-Wdouble-promotion \
		-Wduplicated-branches \
		-Wduplicated-cond \
		-Weffc++ \
		-Wempty-body \
		-Wendif-labels \
		-Wenum-compare \
		-Wexpansion-to-defined \
		-Werror \
		-Wextra \
		-Wextra-semi \
		-Wfloat-conversion \
		-Wformat \
		-Wformat-contains-nul \
		-Wformat-extra-args \
		-Wformat-nonliteral \
		-Wformat-overflow=2 \
		-Wformat-security \
		-Wformat-signedness \
		-Wformat-truncation=2 \
		-Wformat-y2k \
		-Wformat-zero-length \
		-Wformat=2 \
		-Wframe-address \
		-Wfree-nonheap-object \
		-Whsa \
		-Wif-not-aligned \
		-Wignored-attributes \
		-Wignored-qualifiers \
		-Wimplicit-fallthrough=5 \
		-Winherited-variadic-ctor \
		-Winit-list-lifetime \
		-Winit-self \
		-Winline \
		-Wint-in-bool-context \
		-Wint-to-pointer-cast \
		-Winvalid-memory-model \
		-Winvalid-offsetof \
		-Winvalid-pch \
		-Wliteral-suffix \
		-Wlogical-not-parentheses \
		-Wlogical-op \
		-Wlto-type-mismatch \
		-Wmain \
		-Wmaybe-uninitialized \
		-Wmemset-elt-size \
		-Wmemset-transposed-args \
		-Wmisleading-indentation \
		-Wmissing-attributes \
		-Wmissing-braces \
		-Wmissing-declarations \
		-Wmissing-field-initializers \
		-Wmissing-format-attribute \
		-Wmissing-include-dirs \
		-Wmissing-noreturn \
		-Wmissing-profile \
		-Wmultichar \
		-Wmultiple-inheritance \
		-Wmultistatement-macros \
		-Wnarrowing \
		-Wno-deprecated-declarations \
		-Wno-float-equal \
		-Wno-long-long \
		-Wno-namespaces \
		-Wno-padded \
		-Wno-switch-enum \
		-Wno-system-headers \
		-Wno-templates \
		-Wno-undef \
		-Wnoexcept \
		-Wnoexcept-type \
		-Wnon-template-friend \
		-Wnon-virtual-dtor \
		-Wnonnull \
		-Wnonnull-compare \
		-Wnonportable-cfstrings \
		-Wnormalized \
		-Wnull-dereference \
		-Wodr \
		-Wold-style-cast \
		-Wopenmp-simd \
		-Woverflow \
		-Woverlength-strings \
		-Woverloaded-virtual \
		-Wpacked \
		-Wpacked-bitfield-compat \
		-Wpacked-not-aligned \
		-Wparentheses \
		-Wpedantic \
		-Wpessimizing-move \
		-Wplacement-new=2 \
		-Wpmf-conversions \
		-Wpointer-arith \
		-Wpointer-compare \
		-Wpragmas \
		-Wprio-ctor-dtor \
		-Wpsabi \
		-Wredundant-decls \
		-Wredundant-move \
		-Wregister \
		-Wreorder \
		-Wrestrict \
		-Wreturn-local-addr \
		-Wreturn-type \
		-Wscalar-storage-order \
		-Wsequence-point \
		-Wshadow \
		-Wshadow-compatible-local \
		-Wshadow-local \
		-Wshadow=compatible-local \
		-Wshadow=global \
		-Wshadow=local \
		-Wshift-count-negative \
		-Wshift-count-overflow \
		-Wshift-negative-value \
		-Wshift-overflow=2 \
		-Wsign-compare \
		-Wsign-conversion \
		-Wsign-promo \
		-Wsized-deallocation \
		-Wsizeof-array-argument \
		-Wsizeof-pointer-div \
		-Wsizeof-pointer-memaccess \
		-Wstack-protector \
		-Wstrict-aliasing=3 \
		-Wstrict-null-sentinel \
		-Wstrict-overflow=5 \
		-Wstringop-overflow=4 \
		-Wstringop-truncation \
		-Wsubobject-linkage \
		-Wsuggest-attribute=cold \
		-Wsuggest-attribute=const \
		-Wsuggest-attribute=format \
		-Wsuggest-attribute=malloc \
		-Wsuggest-attribute=noreturn \
		-Wsuggest-attribute=pure \
		-Wsuggest-final-methods \
		-Wsuggest-final-types \
		-Wsuggest-override \
		-Wswitch \
		-Wswitch-bool \
		-Wswitch-default \
		-Wswitch-unreachable \
		-Wsync-nand \
		-Wsynth \
		-Wtautological-compare \
		-Wterminate \
		-Wtrampolines \
		-Wtrigraphs \
		-Wtype-limits \
		-Wuninitialized \
		-Wunknown-pragmas \
		-Wunreachable-code \
		-Wunsafe-loop-optimizations \
		-Wunused \
		-Wunused-but-set-parameter \
		-Wunused-but-set-variable \
		-Wunused-const-variable=2 \
		-Wunused-function \
		-Wunused-label \
		-Wunused-local-typedefs \
		-Wunused-macros \
		-Wunused-parameter \
		-Wunused-result \
		-Wunused-value \
		-Wunused-variable \
		-Wuseless-cast \
		-Wvarargs \
		-Wvariadic-macros \
		-Wvector-operation-performance \
		-Wvirtual-inheritance \
		-Wvirtual-move-assign \
		-Wvla \
		-Wvolatile-register-var \
		-Wwrite-strings \
		-Wzero-as-null-pointer-constant \
		"

##########################################################################
# benchmarks
##########################################################################

run_benchmarks:
	rm -fr build_benchmarks
	mkdir build_benchmarks
	cd build_benchmarks ; cmake ../benchmarks -GNinja -DCMAKE_BUILD_TYPE=Release
	cd build_benchmarks ; ninja
	cd build_benchmarks ; ./json_benchmarks

##########################################################################
# fuzzing
##########################################################################

# the overall fuzz testing target
fuzz_testing:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_afl_fuzzer -C test CXX=afl-clang++
	mv test/parse_afl_fuzzer fuzz-testing/fuzzer
	find test/data/json_tests -size -5k -name *json | xargs -I{} cp "{}" fuzz-testing/testcases
	@echo "Execute: afl-fuzz -i fuzz-testing/testcases -o fuzz-testing/out fuzz-testing/fuzzer"

fuzz_testing_bson:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_bson_fuzzer -C test CXX=afl-clang++
	mv test/parse_bson_fuzzer fuzz-testing/fuzzer
	find test/data -size -5k -name *.bson | xargs -I{} cp "{}" fuzz-testing/testcases
	@echo "Execute: afl-fuzz -i fuzz-testing/testcases -o fuzz-testing/out fuzz-testing/fuzzer"

fuzz_testing_cbor:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_cbor_fuzzer -C test CXX=afl-clang++
	mv test/parse_cbor_fuzzer fuzz-testing/fuzzer
	find test/data -size -5k -name *.cbor | xargs -I{} cp "{}" fuzz-testing/testcases
	@echo "Execute: afl-fuzz -i fuzz-testing/testcases -o fuzz-testing/out fuzz-testing/fuzzer"

fuzz_testing_msgpack:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_msgpack_fuzzer -C test CXX=afl-clang++
