=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  graphviz,
  texlive-binaries,
  texlive-latex-base,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://nlohmann.github.io/json/
 Vcs-Git: https://salsa.debian.org/debian/nlohmann-json3.git
